<template>
  <b-container class="full-width-container">
    <h1 class="text-center mt-2">
      Available filters
    </h1>
    <filter-table-list
      :error="error"
      :fetch-filters="fetchFilters"
      :show-admin-view="isUserAdmin"
      :status="status"
      :toggle-filter-visibility="toggleFilterVisibility"
      :visibility-error-msg="visibilityErrorMsg"
    />
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';
import { FilterService } from '@/api';
import { Error } from '@/api/client/middleware/error';
import { LIST_STATUS } from '@/common/constants';
import { Filter, RequestQuery } from '@/common/types';
import FilterTableList from '@/components/Filter/TableList.vue';

export default Vue.extend({
  components: {
    FilterTableList,
  },

  data() {
    return {
      error: {},
      status: LIST_STATUS.LOADING,
      visibilityErrorMsg: '',
    };
  },

  computed: {
    ...mapGetters(['isUserAdmin']),
  },

  methods: {
    async fetchFilters(query: Partial<RequestQuery>) {
      this.status = LIST_STATUS.LOADING;
      try {
        const response = await FilterService.list({ ...query, include: 'owner' });
        const { meta: { count } } = response;
        this.status = count === 0 ? LIST_STATUS.EMPTY : LIST_STATUS.SUCCESS;
        return response;
      } catch (errors) {
        const { 0: error } = errors as Error[]; // errors obj has indexed keys but it's not an array
        this.error = error;
        this.status = LIST_STATUS.ERROR;
      }
      return null;
    },
    async toggleFilterVisibility(filter: Filter): Promise<boolean> {
      const toggleFn = filter.public ? FilterService.makePublic : FilterService.makePrivate;
      try {
        await toggleFn(filter.id);
        this.visibilityErrorMsg = '';
        return true;
      } catch (errors) {
        const { 0: error } = errors as Error[]; // errors obj has indexed keys but it's not an array
        this.visibilityErrorMsg = JSON.stringify(error, null, 2);
        return false;
      }
    },
  },
});
</script>
